//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// デバッガ (定義とか)
//

#pragma once

#include "header.h"
#include <vector>

class Debugger;
class DebuggerMD;
class DebuggerMemoryStream;

using ConstStringPair = std::pair<const std::string, const std::string>;
using HelpMessages = std::vector<ConstStringPair>;

enum class MemoryMode : bool
{
	Logical  = false,
	Physical = true,
};

enum class MMULookupMode : bool
{
	False = false,
	True  = true,
	// MemoryMode::Physical ならこの項は意味を持たないので、
	// True でも False でもないと言いたい。
	None  = false,
};

enum class CPUArch
{
	M680x0,
	M88xx0,
	HD64180,
};
