//
// nono
// Copyright (C) 2023 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class X68kIODevice;

class ExtAreaDevice : public IODevice
{
	using inherited = IODevice;

	static const int baseaddr = 0xeae000;

 public:
	ExtAreaDevice();
	~ExtAreaDevice() override;

	bool Init() override;
	void ResetHard(bool poweron) override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	X68kIODevice *x68kio {};
};
