//
// nono
// Copyright (C) 2023 nono project
// Licensed under nono-license.txt
//

//
// MSX-DOS コマンドラインエミュレータ
//

#pragma once

#include "prom.h"

class MPU64180Device;

class MSXDOSDevice : public PROMDevice
{
	using inherited = PROMDevice;

	// データの受け渡し用。
	struct data_t {
		uint8 *data;
		int size;
	};

 public:
	MSXDOSDevice();
	~MSXDOSDevice() override;

	bool Init() override;

	// MSXDOS コールエミュレーション
	void Syscall();

 private:
	data_t LoadBinary(const char *filename);

	MPU64180Device *xp {};
};
